/* yasep/GNL/graph.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created jeu. mai  3 02:16:49 CEST 2012 by whygee@f-cpu.org
This file contains the "dataflow graph editor"
(control flow will come later...)
*/

init_obj.push(graph={
  win: null,
  serial:0,

//////////////////////////////////////////////

  reflow:function(r,n,t){
    while (true) {
      r.number=n;
      if (r.className=="outputs") { // End of table reached, special treatment
        t.row_last=t.row_output.previousSibling;
        t.row_first=t.row_input.nextSibling;
        t.rows_number=n;
        return;
      }
      r.number_id.firstChild.innerHTML="&nbsp;<br>"+(n++)+"<br>&nbsp;";
      r=r.nextSibling;
    }
  },

//////////////////////////////////////////////

  click:function(ev) {
/*    var t=this.parentNode;
    if (ev.ctrlKey)
      graph.delete_row(t);
    else
      graph.add_row(t);
*/
    graph.add_row(this.parentNode);
  },

  delete_row:function(r) { // the TR
    var n=r.number,
        s=r.nextSibling;
        t=r.parentNode; // the table
    if (r.className=="outputs") // Don't remove the last row (output) or a non-empty row
      return;
    t.removeChild(r);
    graph.reflow(s,n,t);
  },

  add_row:function(r) { // the TR
    var n=r.number,
        t=r.parentNode; // the table
    t.insertBefore(graph.create_row(n,1), r);
    graph.reflow(r.previousSibling,n,t);
  },

  add_input:function() {
    var t=this.parentNode.parentNode,
        u=palette.create_node([
            [{number:t.serial_in}], [{port:"port"}], "#9F9", "input_"+t.serial_in++ 
          ],2);
    t.row_input.NodeDiv.appendChild(u);
    t.row_input.NodeDiv.appendChild(graph.create_inter(2));
    palette.fix(u);
  },

  add_output:function() {
    var t=this.parentNode.parentNode,
        u=palette.create_node([
            [{port:"port"}], [{result:"uuu"}], "#99F", "output_"+t.serial_out++
          ],3);
    t.row_output.NodeDiv.appendChild(u);
    t.row_output.NodeDiv.appendChild(graph.create_inter(3));
    palette.fix(u);
  },

///////////////////////////////////////////
  ondrop_row:function(){
    //  ....
    graph.onmouseout_row();
  },

  onmousein_row:function(){
    if(dragndrop.dragdropstate==4
        && this!=dragndrop.selected){
      this.style.borderWidth="3px";
      this.style.margin="0px";
      dragndrop.destination=this;
      dragndrop.ondrop=graph.ondrop_row; // Indicate that it's ok to drop here
    }
    return false;
  },

  onmouseout_row:function(){
    var t=dragndrop.destination;
    if(!t ||  t.style.borderWidth=="0px")
      return
    t.style.borderWidth="0px";
    t.style.margin="3px";
    dragndrop.destination=
    dragndrop.ondrop=null;
    return false;
  },

///////////////////////////////////////////
  inter_left:null,
  inter_right:null,

  ondrag_node:function(root){
    graph.inter_left=root.nextSibling;
    graph.inter_right=root.previousSibling; // ok
  },

  ondrop_node:function(){
    if(dragndrop.destination){
      graph.onmouseout_inter(); // destination=?
      // move the block there
    }
    else {
      // dropping nowere
    }
  },

  ondelete_node:function(){
    var d=dragndrop.selected.dnd.root;
    var p=d.parentNode;
    p.removeChild(d.nextSibling);    
    p.removeChild(d);
    // search the parent TR to deduce the number of div, then decrement the item count
    if(!(--p.parentNode.parentNode.items))
      alert("vide");
  },

  onmousein_inter:function(){
    if((dragndrop.dragdropstate==this.state)
      // Check that we're not moving to a direct neighbour
      &&(this!=graph.inter_left) &&  (this!=graph.inter_right)){

      this.style.borderWidth="3px";
      this.style.margin="0px";
      (dragndrop.destination=
         this).onmouseout=graph.onmouseout_inter;
      dragndrop.ondrop=graph.ondrop_node;
    }
    return false;
  },

  onmouseout_inter:function(){
    var t=dragndrop.destination;
//    if(!t ||  this!=t)
//      return
    if (t){
      t.style.borderWidth="0px";
      t.style.margin="3px";
      t.onmouseout=
      dragndrop.ondrop=
      dragndrop.destination=null;
    }
    return false;
  },

  create_inter:function(state){
    var d=document.createElement("DIV");
    d.innerHTML="&nbsp;<br>&nbsp;<br>&nbsp;";
    d.className="inter";
    d.state=state;
    d.onmouseover=graph.onmousein_inter;
//    d.onmouseout =graph.onmouseout_inter;
    return d;
  },

///////////////////////////////////////////

  create_row: function(n,t) {
    var classes=["plus", "number", "nodes", "bin_out", "asm_out"],
        r=document.createElement("TR"),c,d,j,k;
    r.number=n;
    r.items=0;
    for (j in classes) {
      c=document.createElement("TD");
      c.className=
        k=classes[j];
      r[k+"_id"]=c;

      switch (k) {
        case "plus":
          if((t!=1)&&(t!=3))
            break;
          c.onclick=graph.click;
          c.title="add a row";
          break;

        case "number":
          if (t==1) { // that is : it's not an input or output
            d=document.createElement("DIV");
            d.onmouseover=graph.onmousein_row;
            d.onmouseout =graph.onmouseout_row;
            d.className="NumberOver";
            d.title="move up/down or to trash";	
            dragndrop.register(d, {
              trashBin:true, // allow move to the trash / erase
              ondelete:function(){
                graph.delete_row(r);
              },
              state:4, root:r
            });
            c.appendChild(d);
          }
          break;

        case "nodes": // Create 2 DIVs
          d=document.createElement("DIV");
          d.className="NodeDiv";
          d.appendChild(graph.create_inter(t));
          c.appendChild(d);
          r.NodeDiv=d;

          d=document.createElement("DIV");
          d.className="ShuffleDiv";
          d.innerHTML="&nbsp;";
          d.state=1;
          d.onmouseover=graph.onmousein_inter;
//          d.onmouseout =graph.onmouseout_inter;
          c.appendChild(d);
          r.ShuffleDiv=d;
          break;

        case "asm_out":
        case "bin_out":
          c.innerHTML="&nbsp;";
          break;

        default:
          c.innerHTML=classes[j];
      }
      r.appendChild(c);
    }
    return r;
  },

  start: function() {
    var c,r,t,g="graph_"+graph.serial++,
        i, j, k, win, cont=(graph.cont=document.createElement("DIV"));
        cont.innerHTML=import_htmi("GNL/graph");
    win = ygwm.new_window( "GNL&nbsp;-&nbsp;"+g,null, cont,
       450, 350, 100, 120, false, true, true, true, false, "WinOK");

    // update the graph name :
    (win.name_id=getByClass("graph_name","SPAN",win)).innerHTML=win.FuncName=g;
    edit_text.register(win.name_id, { size:40,
       func: function(t){ ygwm.changeWinTitle(win, "GNL&nbsp;-&nbsp;"+(win.FuncName=t.source), true) },
       check: edit_text.filter_alpha });

    // create the inputs, outputs and some empty rows inbetween
    t=document.createElement("TABLE");
    t.className="graph";

    for (i=0; i<4; i++) {
      switch(i){
        case 0 : j=2; break;
        case 3 : j=3; break;
        default: j=1; break;
      }
      r=graph.create_row(i, j);
      if (i==0){
        t.row_input=r;
        r.className="inputs";
        r.number_id.innerHTML="";
        r.number_id.className="plus";
        r.number_id.title="add an input";
        r.number_id.onclick=graph.add_input;
/*        r.asm_out_id.innerHTML=
        r.bin_out_id.innerHTML=" ";*/
        r.plus_id.innerHTML="?";
        r.plus_id.className="number";
        r.plus_id.onclick=null;
      }
      t.appendChild(r);
    }
    // last row:
    r.className="outputs";
    r.number_id.innerHTML="";
    r.number_id.className="plus";
    r.number_id.title="add an output";
    r.number_id.onclick=graph.add_output;
    r.nodes_id.removeChild(r.ShuffleDiv); // delete the last useless shuffle div
    t.row_output=r;
    t.rows_number=0;

    graph.reflow(t.row_input.nextSibling,1,t);

    cont.appendChild(t);

    t.serial_in=1;
    t.row_input.number_id.onclick();

    r=t.row_first.NodeDiv;
    r.appendChild(palette.create_node(lib_nodes.arith[0],1));
    r.appendChild(graph.create_inter(1));
    r.appendChild(palette.create_node(lib_nodes.arith[1],1));
    r.appendChild(graph.create_inter(1));
    r.appendChild(palette.create_node(lib_nodes.arith[2],1));
    r.appendChild(graph.create_inter(1));
    r.appendChild(palette.create_node(lib_nodes.arith[3],1));
    r.appendChild(graph.create_inter(1));

    r=t.row_last.NodeDiv;
    r.appendChild(palette.create_node([ [{port:"input1"}, {port:"input2"}, {port:"input3"} ],
           [{port:"output1"}, {port:"output2"} ], "#F99", "exemple1" ],1));
    r.appendChild(graph.create_inter(1));

    r.appendChild(palette.create_node([ [{port:"input1"}, {port:"input2"} ],
          [{port:"output1"}, {port:"output2"}, {port:"output3"} ], "#F99", "exemple2" ],1));
    r.appendChild(graph.create_inter(1));

    t.row_last.items=2;

    t.serial_out=1;
    t.row_output.number_id.onclick();

// Fix sizes AFTER display/append
    palette.fix_sizes(t);

    return (graph.win=win);
  },

  init_obj: function(){
    menu.subMenuItem(menu.list["GNL"],["Edit&nbsp;a&nbsp;graph","Éditer&nbsp;un&nbsp;graphe"], "GNL/graph");
  }
});
