/*
  yasep/dev/minimize.js : réduit la taille de code JS et CSS
  created mar. oct. 18 13:24:47 CEST 2011 by whygee@f-cpu.org
  version mar. nov. 15 10:41:28  CET 2011
  version lun. nov. 21 12:29:49  CET 2011
  version mar. févr. 14 17:52:09 CET 2012 : CSS != //

    Copyright (C) 2011 Yann Guidon

Le code JavaScript de cette page est un logiciel libre : vous pouvez
le redistribuer et/ou le modifier selon les termes de la licence GNU
Affero General Public License (GNU GPL) telle que publiée par la Free
Software Foundation, en version 3 de la licence, ou (à votre discrétion)
toute version suivante. Le code est distribué SANS AUCUNE GARANTIE ;
sans même la garantie implicite de MARCHANDABILITÉ ou d'ADÉQUATION
À UN BUT PARTICULIER.  Consultez la GNU AGPL pour plus de détails.
http://www.gnu.org/licenses/agpl.html


TODO : distinguer blacklist() et method()
*/

JSkeyWords="abstract break boolean byte char class case catch class const continue"
 +" debugger default delete do double else enum export extends"
 +" final finally float for function goto if implements import in Infinity instanceof"
 +" int interface import let long NaN native new package private protected"
 +" public return short static super switch synchronized this throw throws transient try"
 +" typeof undefined var void volatile while with yield blackList arguments";

JS_Methods= "childNodes firstChild lastChild previousSibling nextSibling parentNode id className"
 +" getElementById getElementsByTagName removeChild replaceChild replaceData"
 +" cloneNode insertBefore appendChild appendData deleteData insertData textContent"
 +" nodeName nodeType nodeValue innerHeight innerWidth innerHTML setAttribute setAttributeNode"
 +" onclick onmouseup onmousemove onmousedown onmouseover event left top right bottom scrollTop"
 +" style body cursor display apply call prototype self location top zIndex scrollLeft"
 +" src length Object indexOf height width backgroundColor caller callee write"
 +" scrollBy scrollTo scrollHeight scrollWidth createElement replace target slice sort"
 +" join split floor random cookie responseText documentElement pageX pageY clientX clientY"
 +" title ceil charAt getTime toGMTString location open send substring srcElement"
 +" href onresize clientWidth clientHeight close styleSheets info charCodeAt hash"
 +" offsetLeft offsetTop push pop onchange onload value action color checked colSpan"
 +" constructor lastIndexOf onreadystatechange readyState setRequestHeader onsubmit"
 +" onmouseout toLowerCase toUpperCase timeStamp StyleSheets insertRule setTime cssRules";

New_Methods="";

Aliasable="true false null" // valeurs de base
+" alert clearTimeout escape eval parseInt parseFloat setTimeout unescape" // fonctions, dont celles de l'objet global
+" Array Boolean console Date document Error Function Math Number RegExp String window XMLHttpRequest"; // objets

JSbaseObjects="arguments"  // celui-ci n'est pas aliasable
+" Array Boolean console Date document Error Function Math Number RegExp String window XMLHttpRequest";


minimize=function(src,level,dbg,css) {
  var src_index=0, l=src.length, i,
    substNum="",
    variableChar=[],
    variableCharStrings="#0123456789_$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
    VarCharIndex=[], // table vide
    enumTypes="EOF SPACE WORD STRING NUMBER PUNCT CURLY SEMICOLON REGEXP KEYWORD COLON INTERNAL EXTERNAL EMPTY METHOD".split(" ");

  for (i in enumTypes)
    this[enumTypes[i]]=i;

//console.info("METHOD="+METHOD);

  for (t in variableCharStrings)
    variableChar[variableCharStrings[t]]=42; // valeur bidon

  var dst=[], dst_type=[];
  for (var i=0; i<5; i++) {
    dst.push("");       // ajoute plein de tokens vides
    dst_type.push(EOF); // pour éviter d'avoir à tester
  }                     // la validité des indices

  // Fabrique une table associative à partir d'une chaine de mots
  function string2LUT(str){
    var a=[], b=str.split(" "), c;
    for (i in b) {
      c=b[i];
      if (c != "")
        a["P"+c]=i;
    }
    return a;
  }

  var ParsedWordsLUT    =[],   // indices : string avec préfixe "P"
      ParsedWordsArray  =[], // indices entiers
      JSbaseObjectsLUT  =string2LUT(JSbaseObjects),
      AliasableLUT      =string2LUT(Aliasable),
      JS_MethodsLUT     =string2LUT(JS_Methods+" "+DynamicBlackListWords),
      JSkeyWordsLUT     =string2LUT(JSkeyWords),
      occupied="";

  function newVarName() {
    var v, i;
    do {
      // incrémente les compteurs en propageant la retenue
      i=0;
      do {
        if (i>= VarCharIndex.length) // s'il n'existe pas,
          VarCharIndex[i]=10;        // crée un nouveau chiffre à "_"

        VarCharIndex[i]++;
        if (VarCharIndex[i] < variableCharStrings.length)
          break; // arrête si aucune retenue à propager.

        VarCharIndex[i++]=1; // saute le "#"
      } while (true);

      // concatène les chiffres dans v dans l'ordre décroissant
      v="";
      for (i in VarCharIndex)
        v=variableCharStrings[VarCharIndex[i]]+v;

      if (!JSkeyWordsLUT["P"+v]
           && !ParsedWordsLUT["P"+v]
           && !ParsedWordsLUT["Q"+v])
        break;

      occupied+=" "+v;
    } while (1);
    return v
  }

//////////////// L'analyse lexicale ////////////////

  function getChar() {
    if (src_index>=l)
      return null;
    return src[src_index++];
    // utiliser src.charAt() si compatibilité avec Internet Explorer...
  }

  function compact_number(token) {
    var t=+token, // convertit la chaîne en nombre
    e=0, // exposant

    // Tente une conversion avec exposant décimal
    u=t+"", v=u; // reconvertit en décimal
    while((u.length>1) && (u[u.length-1]=="0")){
      u=u.slice(0,-1); // enlève le dernier 0
      e++;
    }
    if (e>2)
      v=u+"E"+e; // 123E4

    if (token.length > v.length) {
      substNum+=token+" => "+v+"\n";
      token=v;
    }

    // Tente une conversion à décalage
    e=0;
    u=t;
    while ((u>1) && !(u&1)) { // décale tant que le LSB est à 0
      u>>>=1;
      e++;
    }
    v=u+"<<"+e;
    if (token.length > v.length) {
      substNum+=token+" => "+v+"\n";
      token=v;
    }

    return token;
  }

  function getToken() {
    var t=getChar(); // lit un premier caractère
    token=t;         // assignation spéculative

    switch(t){
      case null:  return EOF;

      case " ":  // Espaces :
      case "\t":
      case "\r":
      case "\n":
        token=" ";
        do
          t=getChar();
        while ((t==" ") || (t=="\r")  || (t=="\n") || (t=="\t"));
        if (t==null)
          return EOF;
        src_index--; // retourne le caractère non-espace
        return SPACE;

      case "'":
      case '"':
        var u, v;
        do {
          u=getChar();
          if (u==null) { alert("chaine non fermée"); return EOF }

          // caractère d'échappement ?
          if (u=="\\") {
            v=getChar();
            if (v==null) { alert("chaine non fermée"); return EOF }
            token+=u+v;  // recopie les deux caractères
          }
          else
            token+=u;
        } while (t!=u); // caractère de fermeture = ouverture

        return STRING;

      case "/":
        u=getChar();
        switch(u) {
          case "/":
            if (css) {  // 20120214: ne bousille pas les images inlinées
              token+=u;
              return PUNCT;
            }

            do { // enlever jusqu'à la fin de la ligne
              u=getChar();
            } while ((u!="\n")&&(u != null));
            token=" ";
            return SPACE;

          case "*":
            token=" "; 
            do { // enlever jusqu'à "*/"
              u=getChar();
              if (u=="*"){
                u=getChar();
                if (u=="/")
                  return SPACE;
              }
            } while (u != null);
            alert("commentaire non fermé");
            return EOF;

      default: // Est-ce une regexp ?
        if ((src_index > 3) && (src[src_index-3]=="(")) {
          token+=u;

          do { // recopie tout jusqu'au "/" fermant
            u=getChar();
            if (u==null) {
              alert("regex non fermée"); return EOF }

            if (u=="\\") { // caractère d'échappement
              v=getChar();
              if (v==null) {
                alert("regex non fermée"); return EOF }
              token+=u+v;
            }
            else
              token+=u;
          } while (u!="/");

          // récupère les éventuels caractères à la fin
          while ( variableChar[u=getChar()] )
            token+=u;

          if (u!=null)
            src_index--;

          return REGEXP;
        }  // "else" implicite

        // Juste un "/" seul
        if (u!=null)
          src_index--; // retourne en arrière
        return PUNCT;
      } // fin du switch "/"

      case "}": return CURLY;
      case ";": return SEMICOLON;

      default:
        if (variableChar[t]) {
          do { // un "mot"
            t=getChar();
            if (variableChar[t])
              token+=t;
            else {
              if (t!=null)
                src_index--;

              // à cet endroit, token contient le mot entier,
              // on va vérifier si c'est un mot-clé à nous.
              if (token=="blackList") {
                token=" ";
                while((t!=";")&&(t!=null))
                  t=getChar(); // Enlève tout jusqu'à ";" inclus
                return SPACE;
              }

              if ((token[0]>="0")&&(token[0]<="9")) {
                // compacte le nombre
                if (level!="noSubst")
                  token=compact_number(token);
                return NUMBER;
              }

              return WORD;
            }
          } while (true);
        }

        return PUNCT; // default du default, tous les autres caractères
    }
  }


//////////////// La substitution des mots ////////////////
  function register_word(token, type, p, i) {
    dst_type[i]=type;
    if (typeof ParsedWordsLUT[p]=="number")
      // incrémente le compteur d'occurences
      ParsedWordsArray[ParsedWordsLUT[p]].count++;
    else {
      // crée une nouvelle entrée dans les deux tableaux pour le mot
      ParsedWordsLUT[p]=ParsedWordsArray.length;
      ParsedWordsArray.push({count:1, name:token, type: type});
    }
  }

  function compact() {
    var t, d, p, h,

      h="", i,  j, k="", l, m, n,
      substLUT=[], aliases="";

    // 1) balayage et classification des tokens

    for (i in dst) {
      t=dst_type[i];
      d=dst[i];
      p="P"+d;
      // les chaînes et les nombres sont directement aliasables :
      if ((t==STRING)  ||  (t==NUMBER))
        register_word(d, t, p, i);
      else
        if (t==WORD) {
          // est-ce un mot-clé ?
          if (JSkeyWordsLUT[p])
            // non aliasable, non remplaçable
            register_word(d, KEYWORD, p, i);
          else {
            // est-ce aliasable ?
            if (AliasableLUT[p])
              register_word(d, EXTERNAL, p, i);
            else {
              // est-ce une méthode ?
              if (dst[i-1]==".") {

                if (JS_MethodsLUT[p] ||        // est-ce une méthode connue ?
                    (dst_type[i-2]==METHOD)||  // une propriété d'une méthode connue ?
                     JSbaseObjectsLUT["P"+dst[i-2]] ){    // une propriété d'un objet de base ?
                  // change le type pour que ce mot soit traité spécialement lors de la substitution
                  // (et laisse une trace pour une éventuelle sous-propriété)
                  register_word(d, METHOD, "Q"+d, i);
                  if (!JS_MethodsLUT[p])
                    New_Methods+=" "+d;
                }
                else
                  // ce n'est pas une méthode connue donc c'est un identifiant substituable
                  register_word(d, INTERNAL, p, i);
              }
              else
                // ce n'est pas une méthode donc on peut substituer le mot tranquillement
                register_word(d, INTERNAL, p, i, i);
            }
          }
        }
    }

    // 2) tri et création de la table de substitution

    // trie ParsedWordsArray par ordre décroissant de .count
    ParsedWordsArray.sort(
      function(a, b) { 
        return b.count - a.count; 
      }
    );

    function substitute(nom) {     
      h+="replaced by "+m;
      substLUT[nom]=m;
      // Le nouveau nom a été "consommé",
      // il en faut un autre maintenant.
      m=newVarName();
    }

    i=0;
    m=newVarName();
    p=m.length;
    while(i < ParsedWordsArray.length) {
      j=ParsedWordsArray[i];
      n=j.name;

      /* affiche le mot substituable (ou pas) */
      h+=pad_left(i,4)+"  "
        +pad_left(j.count,4)+"  "
        +pad_right(enumTypes[j.type],10)+"  "
        +pad_right(n,30)+"  ";

      /* détecte si le mot est utilisé à la fois comme
         propriété privée et comme attribut n */
      if ((j.type!=METHOD)&& ParsedWordsLUT["Q"+n])
        k+=" "+n;

      // pas de remplacement si pas assez d'occurences
      if (j.count>1) {
        l=n.length;

        switch(j.type) {
/*
          // Non aliasable mais remplaçable :
          case INTERNAL:
            // remplacement simple :
            // on compare juste les longueurs des mots
            if (l > m.length)
              substitute('P'+n);
            break;

          // aliasable
          case STRING:
          case NUMBER:
*/
          case EXTERNAL:
            if ((l * j.count) > // espace utilisé normalement
               ((j.count* m.length)  // taille après substitution
                   + l+2+ m.length)) { // taille de la déclaration
              aliases+= m + '=' +n+ ';';
              substitute('P'+n);
            } // alias
            break;

/*
          case METHOD:
            // Méthode : tenir compte aussi des crochets
            if ((l * j.count) > // espace utilisé normalement
                 ((j.count* (m.length+1))  // taille après substitution
                   // on ajoute [  et ]  mais on enlève le .
                     + l+4+ m.length)) { // taille de la déclaration
              // L'ancien mot est transformé en chaîne :
              aliases+= m + '="' +n+ '";';
              substitute('Q'+n);
            }
            // break; fold dans default
*/
          // ne pas remplacer ou aliaser KEYWORD:
          default:
            break;

        } // switch

      } // if i>1 


      h+="\n";
      i++;
    } // while

    if (level=="report") {
      dst=[h+"\n\n* Discovered :\n"+New_Methods
            +"\n\n* both method & private :\n"+k
            +"\n\n* black list :\n"+DynamicBlackListWords
            +"\n\n* already used :\n"+occupied
            +"\n\n* Numbers:\n"+substNum
            +"\n\n* Aliases :\n"+aliases];
      return;
    }

    dst[0]=aliases;

    // 3) substitution
    for (i in dst) {
      u="";

      switch(dst_type[i]) {
        case STRING:
          // ajoute un espace si le caractère précédent était alphanumérique
          v=dst[i-1];
          if (variableChar[v.length-1])
            u=" ";

        case INTERNAL:  // Bug : "$+" avalé en mode page entière, pas js individuel   else w=V." "+w;
        case NUMBER:
        case EXTERNAL:
          t=substLUT["P"+dst[i]];
          if (typeof t == "string")
            dst[i] = u+t;
          break;

        case METHOD:
          t=substLUT["Q"+dst[i]];
          if (typeof t == "string") {
            dst[i] = "["+t+"]";
            dst[i-1]= "" ; // efface le "."
          }
          // break; fold dans default

        default:
          break;

      } // switch
    }
  }

//////////////// L'analyse syntaxique ////////////////

  do {
    TYPE=getToken(); // on pourrait inliner l'appel...

    // Gestion de l'espace précédent
    if ((dst_type[dst.length-1] == SPACE)
      && (  ((TYPE!=WORD)&&(TYPE!=NUMBER))
       ||   ((dst_type[dst.length-2]!=WORD)
          && (dst_type[dst.length-2]!=NUMBER)))) {
        dst.pop();       // enlève ledit espace superflu
        dst_type.pop();
    }

    switch(TYPE){
      case EOF:
        if (level!="noSubst") // saute les substitutions, si c'est une CSS par exemple
          compact();
        // concaténation de tout le tableau dans une chaîne
        return dst.join("");

      case SEMICOLON:  // Enlève ";" lorsqu'il est suivi de ";" ou "}"
        if (dbg)
          token=";\n";
      case CURLY:
        if (dst_type[dst.length-1] == SEMICOLON) {
          dst.pop(); // enlève le ";"
          dst_type.pop();
        }
        dst.push(token); // ajoute le "}"
        dst_type.push(TYPE);
        break;

      case STRING:
/*
        if ((dst[dst.length-1] == "+")
         && (dst_type[dst.length-2] == STRING)
         && (token[0]==dst[dst.length-2][0])) {

          // concatène les deux chaînes
          dst[dst.length-2] =
               dst[dst.length-2].slice(0,-1)  // enlève le dernier caractère
             + token.slice(1);                // enlève le premier caractère

          dst.pop();      // enlève le "+"
          dst_type.pop();
          break; // n'ajoute pas token à dst
        }
*/
        // else implicite, saute au code par défaut

      case NUMBER:
      case WORD :
      case REGEXP:
      case SPACE:  // pas de traitement spécial
      case PUNCT: 
        // ajout d'un token
        dst.push(token);
        dst_type.push(TYPE); 
        break;

      default:
        alert("token "+TYPE+" inconnu");
        return "Erreur !!! "+ dst;
    }
  } while (true);
}
