/*
 docs/16-32.js
 This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
 created 20110915 by whygee@f-cpu.org

Lists the YASEP32 and YASEP16 opcodes
*/

DOC_GEN.valid_keys["16-32"]={
  titles:["16&nbsp;vs&nbsp;32&nbsp;bits",
          "16&nbsp;ou&nbsp;32&nbsp;bits&nbsp;?"],
  onLoad: function(cont, h){
    var f, Usage16=[], Usage32=[];

    // scan the list of opcodes
    for (var name in Y.table_opcode) {
      if (Y.table_opcode[name].forms>0) {
        f=Y.table_opcode[name].flags;
        if (Y.YASEP16_ONLY & f)
          Usage16.push(Y.decorate_opcode(name));
        if (Y.YASEP32_ONLY & f)
          Usage32.push(Y.decorate_opcode(name));
      }
    }

    if(Usage16.length)
      getById("y16","div",cont).innerHTML=Usage16.sort().join(" ");
    if(Usage32.length)
      getById("y32","div",cont).innerHTML=Usage32.sort().join(" ");
  }
};
